﻿namespace Tornado
{
    using System;
    using System.Windows.Forms;
    using GTA;
    using GTA.Native;

    public class One : Script
    {
        const float FORCE = 1f;
        //Camera cam;
        private static Vector3 _center, _destination;
        private static float _distance = 150f;
        internal static Vector3 Center
        {
            get { return _center; }
        }
        internal static Vector3 Destination
        {
            get { return _destination; }
        }
        internal static float Distance
        {
            get { return _distance; }
        }
        Blip[] blipArray;
        Random random;
        public One()
        {
            random = new Random();
            blipArray = new Blip[21];
            BindKey(Keys.End, ToggleCam);
            //cam = new Camera();
            //Interval = 500;
        }

        float i; bool upper = true, camOn; float z, radius = 1f, h, k, moveCount; int count, offsetDirection;

        private void Main_Tick(object sender, EventArgs e)
        {
            if (upper)
            {
                upper = i < 21;
                i = upper ? i : 19;
            }
            else
            {
                upper = i < 0;
                z = upper ? _center.Z : z;
                radius = upper ? 1f : radius;
                i = upper ? 1f : i;
                count = upper ? 0 : count;
                if (upper)
                {
                    foreach (Blip blip in blipArray) { if (Game.Exists(blip)) blip.Delete(); }
                }
            }

            if (moveCount == 0) offsetDirection = random.Next(0, 4);

            _destination = moveCount == 0 ? World.GetNextPositionOnStreet(Game.LocalPlayer.Character.Position.Around(random.Next(0, 100))) : _destination;
            _center = moveCount == 0 ? PlayerOffset(offsetDirection == 0 ? Vector3.RelativeLeft * _distance : offsetDirection == 1 ? Vector3.RelativeRight * _distance : offsetDirection == 2 ? Vector3.RelativeFront * _distance : Vector3.RelativeBack * _distance) : _center + Vector3.Normalize(_destination - _center);
            moveCount++;
            moveCount = moveCount > _distance * 2 ? 0 : moveCount;
            h = _center.X; k = _center.Y;
            //DisplayInfo();
            float x = OffsetXY(h, radius - (i * radius) / 10);
            Vector3 offset1 = new Vector3(x, GetY(h, k, x, upper), z);
            //cam.Position = offset1; cam.LookAt(Game.LocalPlayer.Character);
            blipArray[count] = Blip.AddBlip(offset1); blipArray[count].Scale = 0.5f;
            blipArray[count].Color = BlipColor.Cyan;
            z += 0.5f; radius++;
            //z = z > 4f ? 0 : z;
            //radius = radius > 29f ? 21f : radius;
            if (upper) i += 2f;
            else i -= 2f;
            count++;

            foreach (GTA.Object obj in World.GetAllObjects())
            {
                if (!Game.Exists(obj)) continue;
                if (obj.Position.DistanceTo(_center) > 15f) continue;

                obj.ApplyForce(Vector3.Normalize(offset1 - obj.Position) * FORCE);
            }
            foreach (Vehicle veh in World.GetVehicles(_center, 15f))
            {
                if (!Game.Exists(veh)) continue;

                veh.ApplyForce(Vector3.Normalize(offset1 - veh.Position) * FORCE);
            }
            foreach (Ped ped in World.GetPeds(_center, 15f))
            {
                if (!Game.Exists(ped)) continue;


                ped.ApplyForce(Vector3.Normalize(offset1 - ped.Position) * FORCE);
                ped.isRagdoll = true;
            }
            //Wait(500);
        }

        private void DisplayInfo()
        {
            Game.DisplayText("X Position: " + i.ToString() + Environment.NewLine +
                             "Center: " + _center.ToString() + Environment.NewLine +
                             "Radius: " + radius.ToString() + Environment.NewLine +
                             "Z: " + z.ToString() + Environment.NewLine +
                             "Count: " + count.ToString());
        }
        private void ToggleCam()
        {
            camOn = !camOn;
            if (camOn)
            {
                Tick += Main_Tick;
                //if (!cam.isActive) cam.Activate();
            }
            else
            {
                Tick -= Main_Tick; i = 0; z = 0; radius = 1f; moveCount = 0;
                foreach (Blip blip in blipArray) { if (Game.Exists(blip)) blip.Delete(); }
                //if (cam.isActive) cam.Deactivate();
            }
        }
        private Vector3 PlayerOffset(Vector3 offset)
        {
            return Game.LocalPlayer.Character.GetOffsetPosition(offset);
        }
        private float OffsetXY(float hk, float offset)
        {
            return hk + offset;
        }
        private float GetX(float h, float k, float y, bool upper)
        {
            float x = (upper ? 1 : -1) * (float)Math.Sqrt(Math.Pow((double)radius, 2) - Math.Pow((double)y - (double)k, 2)) + h;
            return x;
        }
        private float GetY(float h, float k, float x, bool upper)
        {
            float y = (upper ? 1 : -1) * (float)Math.Sqrt(Math.Pow((double)radius, 2) - Math.Pow((double)x - (double)h, 2)) + k;
            return y;
        }
    }
    public class Two : Script
    {
        const float FORCE = 1f;
        //Camera cam;
        Vector3 center, destination;
        Blip[] blipArray;

        public Two()
        {
            blipArray = new Blip[21];
            BindKey(Keys.End, ToggleCam);
            //cam = new Camera();
            //Interval = 500;
        }

        float i; bool upper, camOn; float z, radius = 1f, h, k, moveCount; int count;
        private void Main_Tick(object sender, EventArgs e)
        {
            if (upper)
            {
                upper = i > -1;
                z = !upper ? center.Z : z;
                radius = !upper ? 1f : radius;
                i = !upper ? 1f : i;
                count = !upper ? 0 : count;
                if (!upper)
                {
                    foreach (Blip blip in blipArray) { if (Game.Exists(blip)) blip.Delete(); }
                }
            }
            else
            {
                upper = i > 20;
                i = !upper ? i : 19;
            }

            destination = One.Destination;
            center = One.Center;
            moveCount++;
            moveCount = moveCount > One.Distance * 2 ? 0 : moveCount;
            h = center.X; k = center.Y;
            //DisplayInfo();
            float x = OffsetXY(h, -1 * radius + (i * radius) / 10);
            Vector3 offset1 = new Vector3(x, GetY(h, k, x, upper), z);
            //cam.Position = offset1; cam.LookAt(Game.LocalPlayer.Character);
            blipArray[count] = Blip.AddBlip(offset1); blipArray[count].Scale = 0.5f;
            blipArray[count].Color = BlipColor.Cyan;
            z += 0.5f; radius++;
            //z = z > 4f ? 0 : z;
            //radius = radius > 29f ? 21f : radius;
            if (!upper) i += 2f;
            else i -= 2f;
            count++;

            foreach (GTA.Object obj in World.GetAllObjects())
            {
                if (!Game.Exists(obj)) continue;
                if (obj.Position.DistanceTo(center) > 15f) continue;

                obj.ApplyForce(Vector3.Normalize(offset1 - obj.Position) * FORCE);
            }
            foreach (Vehicle veh in World.GetVehicles(center, 15f))
            {
                if (!Game.Exists(veh)) continue;

                veh.ApplyForce(Vector3.Normalize(offset1 - veh.Position) * FORCE);
            }
            foreach (Ped ped in World.GetPeds(center, 15f))
            {
                if (!Game.Exists(ped)) continue;


                ped.ApplyForce(Vector3.Normalize(offset1 - ped.Position) * FORCE);
                ped.isRagdoll = true;
            }
            //Wait(500);
        }

        private void DisplayInfo()
        {
            Game.DisplayText("X Position: " + i.ToString() + Environment.NewLine +
                             "Center: " + center.ToString() + Environment.NewLine +
                             "Radius: " + radius.ToString() + Environment.NewLine +
                             "Z: " + z.ToString() + Environment.NewLine +
                             "Count: " + count.ToString());
        }
        private void ToggleCam()
        {
            camOn = !camOn;
            if (camOn)
            {
                Wait(100);
                Tick += Main_Tick;
                //if (!cam.isActive) cam.Activate();
            }
            else
            {
                Tick -= Main_Tick; i = 0; z = 0; radius = 1f; moveCount = 0;
                foreach (Blip blip in blipArray) { if (Game.Exists(blip)) blip.Delete(); }
                //if (cam.isActive) cam.Deactivate();
            }
        }
        private Vector3 PlayerOffset(Vector3 offset)
        {
            return Game.LocalPlayer.Character.GetOffsetPosition(offset);
        }
        private float OffsetXY(float hk, float offset)
        {
            return hk + offset;
        }
        private float GetX(float h, float k, float y, bool upper)
        {
            float x = (upper ? 1 : -1) * (float)Math.Sqrt(Math.Pow((double)radius, 2) - Math.Pow((double)y - (double)k, 2)) + h;
            return x;
        }
        private float GetY(float h, float k, float x, bool upper)
        {
            float y = (upper ? 1 : -1) * (float)Math.Sqrt(Math.Pow((double)radius, 2) - Math.Pow((double)x - (double)h, 2)) + k;
            return y;
        }
    }
    public class Three : Script
    {
        const float FORCE = 1f;
        //Camera cam;
        Vector3 center, destination;
        Blip[] blipArray;

        public Three()
        {
            blipArray = new Blip[21];
            BindKey(Keys.End, ToggleCam);
            //cam = new Camera();
            //Interval = 500;
        }

        float i; bool upper, camOn; float z, radius = 1f, h, k, moveCount; int count;
        private void Main_Tick(object sender, EventArgs e)
        {
            if (upper)
            {
                upper = i > -1;
                z = !upper ? center.Z : z;
                radius = !upper ? 1f : radius;
                i = !upper ? 1f : i;
                count = !upper ? 0 : count;
                if (!upper)
                {
                    foreach (Blip blip in blipArray) { if (Game.Exists(blip)) blip.Delete(); }
                }
            }
            else
            {
                upper = i > 20;
                i = !upper ? i : 19;
            }

            destination = One.Destination;
            center = One.Center;
            moveCount++;
            moveCount = moveCount > One.Distance * 2 ? 0 : moveCount;
            h = center.X; k = center.Y;
            //DisplayInfo();
            float y = OffsetXY(k, radius - (i * radius) / 10);
            Vector3 offset1 = new Vector3(GetX(h, k, y, upper), y, z);
            //cam.Position = offset1; cam.LookAt(Game.LocalPlayer.Character);
            blipArray[count] = Blip.AddBlip(offset1); blipArray[count].Scale = 0.5f;
            blipArray[count].Color = BlipColor.Cyan;
            z += 0.5f; radius++;
            //z = z > 4f ? 0 : z;
            //radius = radius > 29f ? 21f : radius;
            if (!upper) i += 2f;
            else i -= 2f;
            count++;

            foreach (GTA.Object obj in World.GetAllObjects())
            {
                if (!Game.Exists(obj)) continue;
                if (obj.Position.DistanceTo(center) > 15f) continue;

                obj.ApplyForce(Vector3.Normalize(offset1 - obj.Position) * FORCE);
            }
            foreach (Vehicle veh in World.GetVehicles(center, 15f))
            {
                if (!Game.Exists(veh)) continue;

                veh.ApplyForce(Vector3.Normalize(offset1 - veh.Position) * FORCE);
            }
            foreach (Ped ped in World.GetPeds(center, 15f))
            {
                if (!Game.Exists(ped)) continue;


                ped.ApplyForce(Vector3.Normalize(offset1 - ped.Position) * FORCE);
                ped.isRagdoll = true;
            }
            //Wait(500);
        }

        private void DisplayInfo()
        {
            Game.DisplayText("X Position: " + i.ToString() + Environment.NewLine +
                             "Center: " + center.ToString() + Environment.NewLine +
                             "Radius: " + radius.ToString() + Environment.NewLine +
                             "Z: " + z.ToString() + Environment.NewLine +
                             "Count: " + count.ToString());
        }
        private void ToggleCam()
        {
            camOn = !camOn;
            if (camOn)
            {
                Wait(200);
                Tick += Main_Tick;
                //if (!cam.isActive) cam.Activate();
            }
            else
            {
                Tick -= Main_Tick; i = 0; z = 0; radius = 1f; moveCount = 0;
                foreach (Blip blip in blipArray) { if (Game.Exists(blip)) blip.Delete(); }
                //if (cam.isActive) cam.Deactivate();
            }
        }
        private Vector3 PlayerOffset(Vector3 offset)
        {
            return Game.LocalPlayer.Character.GetOffsetPosition(offset);
        }
        private float OffsetXY(float hk, float offset)
        {
            return hk + offset;
        }
        private float GetX(float h, float k, float y, bool upper)
        {
            float x = (upper ? 1 : -1) * (float)Math.Sqrt(Math.Pow((double)radius, 2) - Math.Pow((double)y - (double)k, 2)) + h;
            return x;
        }
        private float GetY(float h, float k, float x, bool upper)
        {
            float y = (upper ? 1 : -1) * (float)Math.Sqrt(Math.Pow((double)radius, 2) - Math.Pow((double)x - (double)h, 2)) + k;
            return y;
        }
    }
    public class Four : Script
    {
        const float FORCE = 1f;
        //Camera cam;
        Vector3 center, destination;
        Blip[] blipArray;

        public Four()
        {
            blipArray = new Blip[21];
            BindKey(Keys.End, ToggleCam);
            //cam = new Camera();
            //Interval = 500;
        }

        float i; bool upper = true, camOn; float z, radius = 1f, h, k, moveCount; int count;
        private void Main_Tick(object sender, EventArgs e)
        {
            if (upper)
            {
                upper = i < 21;
                i = upper ? i : 19;
            }
            else
            {
                upper = i < 0;
                z = upper ? center.Z : z;
                radius = upper ? 1f : radius;
                i = upper ? 1f : i;
                count = upper ? 0 : count;
                if (upper)
                {
                    foreach (Blip blip in blipArray) { if (Game.Exists(blip)) blip.Delete(); }
                }
            }

            destination = One.Destination;
            center = One.Center;
            moveCount++;
            moveCount = moveCount > One.Distance * 2 ? 0 : moveCount;

            h = center.X; k = center.Y;
            //DisplayInfo();
            float y = OffsetXY(k, -1 * radius + (i * radius) / 10);
            Vector3 offset1 = new Vector3(GetX(h, k, y, upper), y, z);
            //cam.Position = offset1; cam.LookAt(Game.LocalPlayer.Character);
            blipArray[count] = Blip.AddBlip(offset1); blipArray[count].Scale = 0.5f;
            blipArray[count].Color = BlipColor.Cyan;
            z += 0.5f; radius++;
            //z = z > 4f ? 0 : z;
            //radius = radius > 29f ? 21f : radius;
            if (upper) i += 2f;
            else i -= 2f;
            count++;

            foreach (GTA.Object obj in World.GetAllObjects())
            {
                if (!Game.Exists(obj)) continue;
                if (obj.Position.DistanceTo(center) > 15f) continue;

                obj.ApplyForce(Vector3.Normalize(offset1 - obj.Position) * FORCE);
            }
            foreach (Vehicle veh in World.GetVehicles(center, 15f))
            {
                if (!Game.Exists(veh)) continue;

                veh.ApplyForce(Vector3.Normalize(offset1 - veh.Position) * FORCE);
            }
            foreach (Ped ped in World.GetPeds(center, 15f))
            {
                if (!Game.Exists(ped)) continue;


                ped.ApplyForce(Vector3.Normalize(offset1 - ped.Position) * FORCE);
                ped.isRagdoll = true;
            }
            //Wait(500);
        }

        private void DisplayInfo()
        {
            Game.DisplayText("X Position: " + i.ToString() + Environment.NewLine +
                             "Center: " + center.ToString() + Environment.NewLine +
                             "Radius: " + radius.ToString() + Environment.NewLine +
                             "Z: " + z.ToString() + Environment.NewLine +
                             "Count: " + count.ToString());
        }
        private void ToggleCam()
        {
            camOn = !camOn;
            if (camOn)
            {
                Wait(300);
                Tick += Main_Tick;
                //if (!cam.isActive) cam.Activate();
            }
            else
            {
                Tick -= Main_Tick; i = 0; z = 0; radius = 1f; moveCount = 0;
                foreach (Blip blip in blipArray) { if (Game.Exists(blip)) blip.Delete(); }
                //if (cam.isActive) cam.Deactivate();
            }
        }
        private Vector3 PlayerOffset(Vector3 offset)
        {
            return Game.LocalPlayer.Character.GetOffsetPosition(offset);
        }
        private float OffsetXY(float hk, float offset)
        {
            return hk + offset;
        }
        private float GetX(float h, float k, float y, bool upper)
        {
            float x = (upper ? 1 : -1) * (float)Math.Sqrt(Math.Pow((double)radius, 2) - Math.Pow((double)y - (double)k, 2)) + h;
            return x;
        }
        private float GetY(float h, float k, float x, bool upper)
        {
            float y = (upper ? 1 : -1) * (float)Math.Sqrt(Math.Pow((double)radius, 2) - Math.Pow((double)x - (double)h, 2)) + k;
            return y;
        }
    }
}
